﻿Imports System.ComponentModel
Imports System.Data.Entity

Public Class Form1

    Private _myBloggingContext As BloggingContext

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        _myBloggingContext = New BloggingContext

        '_myBloggingContext.Database.Delete()
        _myBloggingContext.Database.CreateIfNotExists()

        If Not _myBloggingContext.Blogs.Any Then
            Seeding()
        End If


        Dim blogNameList = _myBloggingContext.Blogs.Select(Function(b) b.Name).ToList
        For Each b In blogNameList
            ComboBox1.Items.Add(b)
        Next
        AddHandler ComboBox1.SelectedIndexChanged, AddressOf ComboBox1_SelectedItemChanged
        ComboBox1.SelectedIndex = 0

        AddHandler blogsBindingSource.ListChanged, AddressOf blogsBindingSource_ListChanged


    End Sub

    Private Sub blogsBindingSource_ListChanged(sender As Object, e As ListChangedEventArgs)
        SaveChanges()
    End Sub

    Private Sub ComboBox1_SelectedItemChanged(sender As Object, e As EventArgs)
        _myBloggingContext = New BloggingContext
        Dim blogId As Integer = _myBloggingContext.Blogs.Where(Function(b) b.Name = ComboBox1.SelectedItem.ToString()).Select(Function(s) s.BlogId).Single()
        _myBloggingContext.Posts.Where(Function(b) b.BlogId = blogId).Load()

        blogsBindingSource.DataSource = _myBloggingContext.Posts.Local.ToBindingList()
    End Sub



    Private Sub blogsBindingSource_CurrentItemChanged(sender As Object, e As EventArgs) Handles blogsBindingSource.CurrentItemChanged
        TextBox1.Text = DirectCast(blogsBindingSource.Current, Model.Post).Title
    End Sub

    Private Sub btnSaveTitle_Click(sender As Object, e As EventArgs) Handles btnSaveTitle.Click
        DirectCast(blogsBindingSource.Current, Model.Post).Title = TextBox1.Text
        SaveChanges()
        DataGridView1.Refresh()
    End Sub

    Private Sub SaveChanges()
        If _myBloggingContext.SaveChanges() > 0 Then
            GridStatusLabel.Text = $"Erfolgreich gespeichert zuletzt um {DateTime.Now.TimeOfDay}"
        Else
            GridStatusLabel.Text = $"Letzte speicherung um {DateTime.Now.TimeOfDay} war leider nicht erfolgreich oder es waren keine Änderungen vorhanden."
        End If
    End Sub

    Private Sub DataGridView1_DataError(sender As Object, e As DataGridViewDataErrorEventArgs) Handles DataGridView1.DataError
        Debug.WriteLine(e.Exception.ToString)
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        _myBloggingContext.Dispose()
    End Sub



    Private Sub Seeding()

        Using ctx As New BloggingContext
            ctx.Blogs.Add(New Model.Blog() With {.Name = "Gute Bücher", .Posts = New List(Of Model.Post) From {
                          New Model.Post() With {.Title = "Gutes Buch über Entity Framework?", .From = "User01", .Content = "Kann jemand ein gutes Buch zu EF 6 empfehlen. Danke im Voraus"},
                          New Model.Post() With {.Title = "Ja, ich kenne eines", .From = "NoFear23m", .Content = "Holger Schwichtenberg hat sowohl zum EF6 als auch zum EF Core gute Bücher im Programm."}}})
            ctx.Blogs.Add(New Model.Blog() With {.Name = "WinForms oder WPF?", .Posts = New List(Of Model.Post) From {
                             New Model.Post() With {.Title = "WPF!", .From = "NoFear23m", .Content = "Ich bevorzuge WPF."},
                             New Model.Post() With {.Title = "Eher beides", .From = "User 123", .Content = "Ich bin mehrgleisig unterwegs das meisste erledige ich aber unter WinForms."},
                             New Model.Post() With {.Title = "Nur WinForms", .From = "User 456", .Content = "Mit ist die lernkurve unter WPF zu steil. Ich lass lieber die Finger davon."}}})
            If ctx.SaveChanges = 0 Then
                Throw New Exception("Der Context hat nichts gespeichert, da stimmt etwas nicht.")
            End If
        End Using

    End Sub

End Class
